package industries.sunshine.chartexample

import scala.scalajs.js
import scala.scalajs.js.annotation.*

import org.scalajs.dom

import com.raquo.laminar.api.L.{*, given}

@main
def App(): Unit =
  renderOnDomContentLoaded(
    dom.document.getElementById("app"),
    Main.appElement()
  )

object Main {
  def appElement(): Element =
    div(
      className := "w-screen h-screen bg-green-100",
      renderDataChart(),
    )

  def renderDataChart(): Element = {
    import scala.scalajs.js.JSConverters.*
    // import typings.chartJs.mod.*
      import typings.chartJs.mod.Chart

    // var optChart: Option[Chart] = Some(null)

    // var optChart: Option[Chart] = None

    canvasTag(
      className := "border-4 border-purple-500",
      // Regular properties of the canvas
      width := "100%",
      height := "200px",

      // onMountUnmount callback to bridge the Laminar world and the Chart.js world
      onMountUnmountCallback(
        // on mount, create the `Chart` instance and store it in optChart
        mount = { nodeCtx =>
          val domCanvas: dom.HTMLCanvasElement = nodeCtx.thisNode.ref
          val testChart: Chart = Chart(domCanvas, chartConfig)
          // val chart = Chart.apply.newInstance2(domCanvas, chartConfig)
          // println("on mounting chart")
          // optChart = Some(chart)
        },
        // on unmount, destroy the `Chart` instance
        unmount = { thisNode =>
          // for (chart <- optChart)
          //   chart.destroy()
          // optChart = None
        }
      ),

      // Bridge the FRP world of dataSignal to the imperative world of the `chart.data`
      // dataSignal --> { data =>
      //   for (chart <- optChart) {
      //     chart.data.labels = data.map(_.label).toJSArray
      //     chart.data.datasets.get(0).data = data.map(_.price).toJSArray
      //     chart.data.datasets.get(1).data = data.map(_.fullPrice).toJSArray
      //     chart.update()
      //   }
      // },
    )
  }

  val chartConfig = {
    import typings.chartJs.mod.ChartConfiguration
      ChartConfiguration(
        `type` = "bar"
      )
  }

  // val chartConfig = {
  //   import typings.chartJs.mod.*
  //   new ChartConfiguration {
  //     `type` = ChartType.bar
  //     data = new ChartData {
  //       labels = js.Array("one", "two", "al", "la", "yo")
  //       datasets = js.Array(
  //         new ChartDataSets {
  //           label = "Price"
  //           borderWidth = 1
  //           backgroundColor = "green"
  //           data = js.Array(1,2,3,4,5)
  //         },
  //         new ChartDataSets {
  //           label = "Full price"
  //           borderWidth = 1
  //           backgroundColor = "blue"
  //           data = js.Array(5,5,5,5,5)
  //         }
  //       )
  //     }
  //     options = new ChartOptions {
  //       scales = new ChartScales {
  //         yAxes = js.Array(new CommonAxe {
  //                            ticks = new TickOptions {
  //                              beginAtZero = true
  //                            }
  //                          })
  //       }
  //     }
  //   }
  // }

}
